﻿// Class1.cpp
#include "pch.h"
#include "ComputerPlayer.h"
#include <ppltasks.h>

using namespace concurrency;
using namespace TicTacToe;
using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;

ComputerPlayer::ComputerPlayer(Platform::String^ symbol) : m_symbol(symbol), m_playerType(PlayerType::Computer)
{
    Wins = 0;
}

IAsyncOperationWithProgress<int32, int32>^ ComputerPlayer::ThinkAsync(IVector<wchar_t>^ gameBoard, wchar_t empty, wchar_t knot, wchar_t cross)
{
    return create_async([gameBoard, empty, knot, cross](progress_reporter<int32> reporter)
    {
        for (int i = 0; i < 10; i++)
        {
            concurrency::wait(100);
            reporter.report(i * 10);
        }
        
        while (true)
        {
            int32_t n = rand()%9;
            if (gameBoard->GetAt(n) == empty)
            {
                return n;
            }
        }
    });
}
