#include "pch.h"
#include "Cell.h"
#include "DelegateCommand.h"
#include "GameProcessor.h"

using namespace TicTacToeLibrary;

using namespace Windows::UI::Xaml::Media;

Cell::Cell(uint32_t index, Brush^ foregroundBrush, GameProcessor^ gameProcessor) : m_index(index), m_mark(L'\0'), m_gameProcessor(gameProcessor)
{
    ForegroundBrush = foregroundBrush;
    m_selectCommand = ref new DelegateCommand(ref new ExecuteDelegate(this, &Cell::Select), nullptr);
}

void Cell::Select(Platform::Object^ parameter)
{
    (void)parameter;

    auto gameProcessor = m_gameProcessor.Resolve<GameProcessor>();
    if (m_mark == L'\0' && gameProcessor != nullptr && !gameProcessor->IsThinking && !gameProcessor->CanCreateNewGame)
    {
        m_mark = gameProcessor->CurrentPlayer->Symbol;
        OnPropertyChanged("Text");

        CellSelected(this);
    }
}