﻿#pragma once
#include "IPlayer.h"

namespace TicTacToeLibrary
{
    ref class ComputerPlayer sealed : public IPlayer
    {
    public:
        ComputerPlayer(wchar_t symbol, wchar_t opponentSymbol, wchar_t emptySymbol);

        virtual property PlayerType Player
        {
            PlayerType get()
            {
                return m_playerType;
            }
        }

        virtual property wchar_t Symbol
        {
            wchar_t get()
            {
                return m_symbol;
            }
        }

        virtual Windows::Foundation::IAsyncOperationWithProgress<uint32, double>^ ThinkAsync(Windows::Foundation::Collections::IVector<wchar_t>^ gameBoard);

    private:
        PlayerType m_playerType;
        wchar_t m_symbol;
        wchar_t m_opponentSymbol;
        wchar_t m_emptySymbol;
        std::mt19937 m_rng;
    };
}